diff --git a/compiler/typecheck/TcPat.lhs b/compiler/typecheck/TcPat.lhs
index ae7ef73..04977c2 100644
--- a/compiler/typecheck/TcPat.lhs
+++ b/compiler/typecheck/TcPat.lhs
@@ -6,21 +6,15 @@
 TcPat: Typechecking patterns
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcPat ( tcLetPat, TcSigFun, TcSigInfo(..), TcPragFun 
              , LetBndrSpec(..), addInlinePrags, warnPrags
              , tcPat, tcPats, newNoSigLetBndr
-	     , addDataConStupidTheta, badFieldCon, polyPatSig ) where
+             , addDataConStupidTheta, badFieldCon, polyPatSig ) where
 
 #include "HsVersions.h"
 
-import {-# SOURCE #-}	TcExpr( tcSyntaxOp, tcInferRho)
+import {-# SOURCE #-}   TcExpr( tcSyntaxOp, tcInferRho)
 
 import HsSyn
 import TcHsSyn
@@ -52,16 +46,16 @@ import Control.Monad
 
 
 %************************************************************************
-%*									*
-		External interface
-%*									*
+%*                                                                      *
+                External interface
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 tcLetPat :: TcSigFun -> LetBndrSpec
-      	 -> LPat Name -> TcSigmaType 
-     	 -> TcM a
-      	 -> TcM (LPat TcId, a)
+         -> LPat Name -> TcSigmaType 
+         -> TcM a
+         -> TcM (LPat TcId, a)
 tcLetPat sig_fn no_gen pat pat_ty thing_inside
   = tc_lpat pat pat_ty penv thing_inside 
   where
@@ -70,8 +64,8 @@ tcLetPat sig_fn no_gen pat pat_ty thing_inside
 
 -----------------
 tcPats :: HsMatchContext Name
-       -> [LPat Name]		 -- Patterns,
-       -> [TcSigmaType]	         --   and their types
+       -> [LPat Name]            -- Patterns,
+       -> [TcSigmaType]          --   and their types
        -> TcM a                  --   and the checker for the body
        -> TcM ([LPat TcId], a)
 
@@ -104,8 +98,8 @@ tcPat ctxt pat pat_ty thing_inside
 
 -----------------
 data PatEnv
-  = PE { pe_lazy :: Bool	-- True <=> lazy context, so no existentials allowed
-       , pe_ctxt :: PatCtxt   	-- Context in which the whole pattern appears
+  = PE { pe_lazy :: Bool        -- True <=> lazy context, so no existentials allowed
+       , pe_ctxt :: PatCtxt     -- Context in which the whole pattern appears
        }
 
 data PatCtxt
@@ -113,18 +107,18 @@ data PatCtxt
        (HsMatchContext Name) 
 
   | LetPat   -- Used only for let(rec) pattern bindings
-    	     -- See Note [Typing patterns in pattern bindings]
+             -- See Note [Typing patterns in pattern bindings]
        TcSigFun        -- Tells type sig if any
        LetBndrSpec     -- True <=> no generalisation of this let
 
 data LetBndrSpec 
-  = LetLclBndr		  -- The binder is just a local one;
-    			  -- an AbsBinds will provide the global version
+  = LetLclBndr            -- The binder is just a local one;
+                          -- an AbsBinds will provide the global version
 
   | LetGblBndr TcPragFun  -- Genrealisation plan is NoGen, so there isn't going 
                           -- to be an AbsBinds; So we must bind the global version
                           -- of the binder right away.  
-    	       		  -- Oh, and dhhere is the inline-pragma information
+                          -- Oh, and dhhere is the inline-pragma information
 
 makeLazy :: PatEnv -> PatEnv
 makeLazy penv = penv { pe_lazy = True }
@@ -145,12 +139,12 @@ data TcSigInfo
                            -- Instantiated type and kind variables
                            -- Just n <=> this skolem is lexically in scope with name n
                            -- See Note [Kind vars in sig_tvs]
-                     	   -- See Note [More instantiated than scoped] in TcBinds
+                           -- See Note [More instantiated than scoped] in TcBinds
 
         sig_theta  :: TcThetaType,  -- Instantiated theta
 
         sig_tau    :: TcSigmaType,  -- Instantiated tau
-		      		    -- See Note [sig_tau may be polymorphic]
+                                    -- See Note [sig_tau may be polymorphic]
 
         sig_loc    :: SrcSpan       -- The location of the signature
     }
@@ -197,9 +191,9 @@ res_ty free vars.
 
 
 %************************************************************************
-%*									*
-		Binders
-%*									*
+%*                                                                      *
+                Binders
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -299,9 +293,9 @@ Two cases, dealt with by the LetPat case of tcPatBndr
 
 
 %************************************************************************
-%*									*
-		The main worker functions
-%*									*
+%*                                                                      *
+                The main worker functions
+%*                                                                      *
 %************************************************************************
 
 Note [Nesting]
@@ -318,46 +312,46 @@ Hence the getErrCtxt/setErrCtxt stuff in tcMultiple
 \begin{code}
 --------------------
 type Checker inp out =  forall r.
-			  inp
-		       -> PatEnv
-		       -> TcM r
-		       -> TcM (out, r)
+                          inp
+                       -> PatEnv
+                       -> TcM r
+                       -> TcM (out, r)
 
 tcMultiple :: Checker inp out -> Checker [inp] [out]
 tcMultiple tc_pat args penv thing_inside
-  = do	{ err_ctxt <- getErrCtxt
-	; let loop _ []
-		= do { res <- thing_inside
-		     ; return ([], res) }
-
-	      loop penv (arg:args)
-		= do { (p', (ps', res)) 
-				<- tc_pat arg penv $ 
-				   setErrCtxt err_ctxt $
-				   loop penv args
-		-- setErrCtxt: restore context before doing the next pattern
-		-- See note [Nesting] above
-				
-		     ; return (p':ps', res) }
-
-	; loop penv args }
+  = do  { err_ctxt <- getErrCtxt
+        ; let loop _ []
+                = do { res <- thing_inside
+                     ; return ([], res) }
+
+              loop penv (arg:args)
+                = do { (p', (ps', res)) 
+                                <- tc_pat arg penv $ 
+                                   setErrCtxt err_ctxt $
+                                   loop penv args
+                -- setErrCtxt: restore context before doing the next pattern
+                -- See note [Nesting] above
+                                
+                     ; return (p':ps', res) }
+
+        ; loop penv args }
 
 --------------------
 tc_lpat :: LPat Name 
-	-> TcSigmaType
-	-> PatEnv
-	-> TcM a
-	-> TcM (LPat TcId, a)
+        -> TcSigmaType
+        -> PatEnv
+        -> TcM a
+        -> TcM (LPat TcId, a)
 tc_lpat (L span pat) pat_ty penv thing_inside
   = setSrcSpan span $
-    do	{ (pat', res) <- maybeWrapPatCtxt pat (tc_pat penv pat pat_ty)
+    do  { (pat', res) <- maybeWrapPatCtxt pat (tc_pat penv pat pat_ty)
                                           thing_inside
-	; return (L span pat', res) }
+        ; return (L span pat', res) }
 
 tc_lpats :: PatEnv
-	 -> [LPat Name] -> [TcSigmaType]
-       	 -> TcM a	
-       	 -> TcM ([LPat TcId], a)
+         -> [LPat Name] -> [TcSigmaType]
+         -> TcM a       
+         -> TcM ([LPat TcId], a)
 tc_lpats penv pats tys thing_inside 
   = ASSERT2( equalLength pats tys, ppr pats $$ ppr tys )
     tcMultiple (\(p,t) -> tc_lpat p t) 
@@ -365,68 +359,68 @@ tc_lpats penv pats tys thing_inside
                 penv thing_inside 
 
 --------------------
-tc_pat	:: PatEnv
+tc_pat  :: PatEnv
         -> Pat Name 
-        -> TcSigmaType	-- Fully refined result type
-        -> TcM a		-- Thing inside
-        -> TcM (Pat TcId, 	-- Translated pattern
-                a)		-- Result of thing inside
+        -> TcSigmaType  -- Fully refined result type
+        -> TcM a                -- Thing inside
+        -> TcM (Pat TcId,       -- Translated pattern
+                a)              -- Result of thing inside
 
 tc_pat penv (VarPat name) pat_ty thing_inside
-  = do	{ (co, id) <- tcPatBndr penv name pat_ty
+  = do  { (co, id) <- tcPatBndr penv name pat_ty
         ; res <- tcExtendIdEnv1 name id thing_inside
         ; return (mkHsWrapPatCo co (VarPat id) pat_ty, res) }
 
 tc_pat penv (ParPat pat) pat_ty thing_inside
-  = do	{ (pat', res) <- tc_lpat pat pat_ty penv thing_inside
-	; return (ParPat pat', res) }
+  = do  { (pat', res) <- tc_lpat pat pat_ty penv thing_inside
+        ; return (ParPat pat', res) }
 
 tc_pat penv (BangPat pat) pat_ty thing_inside
-  = do	{ (pat', res) <- tc_lpat pat pat_ty penv thing_inside
-	; return (BangPat pat', res) }
+  = do  { (pat', res) <- tc_lpat pat pat_ty penv thing_inside
+        ; return (BangPat pat', res) }
 
 tc_pat penv lpat@(LazyPat pat) pat_ty thing_inside
-  = do	{ (pat', (res, pat_ct)) 
-		<- tc_lpat pat pat_ty (makeLazy penv) $ 
-		   captureConstraints thing_inside
-		-- Ignore refined penv', revert to penv
+  = do  { (pat', (res, pat_ct)) 
+                <- tc_lpat pat pat_ty (makeLazy penv) $ 
+                   captureConstraints thing_inside
+                -- Ignore refined penv', revert to penv
 
-	; emitConstraints pat_ct
-	-- captureConstraints/extendConstraints: 
+        ; emitConstraints pat_ct
+        -- captureConstraints/extendConstraints: 
         --   see Note [Hopping the LIE in lazy patterns]
 
-	-- Check there are no unlifted types under the lazy pattern
-	; when (any (isUnLiftedType . idType) $ collectPatBinders pat') $
+        -- Check there are no unlifted types under the lazy pattern
+        ; when (any (isUnLiftedType . idType) $ collectPatBinders pat') $
                lazyUnliftedPatErr lpat
 
-	-- Check that the expected pattern type is itself lifted
-	; pat_ty' <- newFlexiTyVarTy liftedTypeKind
-	; _ <- unifyType pat_ty pat_ty'
+        -- Check that the expected pattern type is itself lifted
+        ; pat_ty' <- newFlexiTyVarTy liftedTypeKind
+        ; _ <- unifyType pat_ty pat_ty'
 
-	; return (LazyPat pat', res) }
+        ; return (LazyPat pat', res) }
 
 tc_pat _ p@(QuasiQuotePat _) _ _
   = pprPanic "Should never see QuasiQuotePat in type checker" (ppr p)
 
 tc_pat _ (WildPat _) pat_ty thing_inside
-  = do	{ res <- thing_inside 
-	; return (WildPat pat_ty, res) }
+  = do  { res <- thing_inside 
+        ; return (WildPat pat_ty, res) }
 
 tc_pat penv (AsPat (L nm_loc name) pat) pat_ty thing_inside
-  = do	{ (co, bndr_id) <- setSrcSpan nm_loc (tcPatBndr penv name pat_ty)
+  = do  { (co, bndr_id) <- setSrcSpan nm_loc (tcPatBndr penv name pat_ty)
         ; (pat', res) <- tcExtendIdEnv1 name bndr_id $
-			 tc_lpat pat (idType bndr_id) penv thing_inside
-	    -- NB: if we do inference on:
-	    --		\ (y@(x::forall a. a->a)) = e
-	    -- we'll fail.  The as-pattern infers a monotype for 'y', which then
-	    -- fails to unify with the polymorphic type for 'x'.  This could 
-	    -- perhaps be fixed, but only with a bit more work.
-	    --
-	    -- If you fix it, don't forget the bindInstsOfPatIds!
-	; return (mkHsWrapPatCo co (AsPat (L nm_loc bndr_id) pat') pat_ty, res) }
+                         tc_lpat pat (idType bndr_id) penv thing_inside
+            -- NB: if we do inference on:
+            --          \ (y@(x::forall a. a->a)) = e
+            -- we'll fail.  The as-pattern infers a monotype for 'y', which then
+            -- fails to unify with the polymorphic type for 'x'.  This could 
+            -- perhaps be fixed, but only with a bit more work.
+            --
+            -- If you fix it, don't forget the bindInstsOfPatIds!
+        ; return (mkHsWrapPatCo co (AsPat (L nm_loc bndr_id) pat') pat_ty, res) }
 
 tc_pat penv (ViewPat expr pat _) overall_pat_ty thing_inside 
-  = do	{
+  = do  {
          -- Morally, expr must have type `forall a1...aN. OPT' -> B` 
          -- where overall_pat_ty is an instance of OPT'.
          -- Here, we infer a rho type for it,
@@ -440,69 +434,69 @@ tc_pat penv (ViewPat expr pat _) overall_pat_ty thing_inside
          -- (view -> f)    where view :: _ -> forall b. b
          -- we will only be able to use view at one instantation in the
          -- rest of the view
-	; (expr_co, pat_ty) <- tcInfer $ \ pat_ty -> 
-		unifyType expr'_inferred (mkFunTy overall_pat_ty pat_ty)
+        ; (expr_co, pat_ty) <- tcInfer $ \ pat_ty -> 
+                unifyType expr'_inferred (mkFunTy overall_pat_ty pat_ty)
         
          -- pattern must have pat_ty
         ; (pat', res) <- tc_lpat pat pat_ty penv thing_inside
 
-	; return (ViewPat (mkLHsWrapCo expr_co expr') pat' overall_pat_ty, res) }
+        ; return (ViewPat (mkLHsWrapCo expr_co expr') pat' overall_pat_ty, res) }
 
 -- Type signatures in patterns
 -- See Note [Pattern coercions] below
 tc_pat penv (SigPatIn pat sig_ty) pat_ty thing_inside
-  = do	{ (inner_ty, tv_binds, wrap) <- tcPatSig (patSigCtxt penv) sig_ty pat_ty
-	; (pat', res) <- tcExtendTyVarEnv2 tv_binds $
-			 tc_lpat pat inner_ty penv thing_inside
+  = do  { (inner_ty, tv_binds, wrap) <- tcPatSig (patSigCtxt penv) sig_ty pat_ty
+        ; (pat', res) <- tcExtendTyVarEnv2 tv_binds $
+                         tc_lpat pat inner_ty penv thing_inside
 
         ; return (mkHsWrapPat wrap (SigPatOut pat' inner_ty) pat_ty, res) }
 
 ------------------------
 -- Lists, tuples, arrays
 tc_pat penv (ListPat pats _ Nothing) pat_ty thing_inside
-  = do	{ (coi, elt_ty) <- matchExpectedPatTy matchExpectedListTy pat_ty      
+  = do  { (coi, elt_ty) <- matchExpectedPatTy matchExpectedListTy pat_ty      
         ; (pats', res) <- tcMultiple (\p -> tc_lpat p elt_ty)
-				     pats penv thing_inside
- 	; return (mkHsWrapPat coi (ListPat pats' elt_ty Nothing) pat_ty, res) 
+                                     pats penv thing_inside
+        ; return (mkHsWrapPat coi (ListPat pats' elt_ty Nothing) pat_ty, res) 
         }
 
 tc_pat penv (ListPat pats _ (Just (_,e))) pat_ty thing_inside
-  = do	{ list_pat_ty <- newFlexiTyVarTy liftedTypeKind
+  = do  { list_pat_ty <- newFlexiTyVarTy liftedTypeKind
         ; e' <- tcSyntaxOp ListOrigin e (mkFunTy pat_ty list_pat_ty)
         ; (coi, elt_ty) <- matchExpectedPatTy matchExpectedListTy list_pat_ty
         ; (pats', res) <- tcMultiple (\p -> tc_lpat p elt_ty)
-				     pats penv thing_inside
- 	; return (mkHsWrapPat coi (ListPat pats' elt_ty (Just (pat_ty,e'))) list_pat_ty, res) 
+                                     pats penv thing_inside
+        ; return (mkHsWrapPat coi (ListPat pats' elt_ty (Just (pat_ty,e'))) list_pat_ty, res) 
         }
 
 tc_pat penv (PArrPat pats _) pat_ty thing_inside
-  = do	{ (coi, elt_ty) <- matchExpectedPatTy matchExpectedPArrTy pat_ty
-	; (pats', res) <- tcMultiple (\p -> tc_lpat p elt_ty)
-				     pats penv thing_inside 
-	; return (mkHsWrapPat coi (PArrPat pats' elt_ty) pat_ty, res)
+  = do  { (coi, elt_ty) <- matchExpectedPatTy matchExpectedPArrTy pat_ty
+        ; (pats', res) <- tcMultiple (\p -> tc_lpat p elt_ty)
+                                     pats penv thing_inside 
+        ; return (mkHsWrapPat coi (PArrPat pats' elt_ty) pat_ty, res)
         }
 
 tc_pat penv (TuplePat pats boxity _) pat_ty thing_inside
-  = do	{ let tc = tupleTyCon (boxityNormalTupleSort boxity) (length pats)
+  = do  { let tc = tupleTyCon (boxityNormalTupleSort boxity) (length pats)
         ; (coi, arg_tys) <- matchExpectedPatTy (matchExpectedTyConApp tc) pat_ty
-	; (pats', res) <- tc_lpats penv pats arg_tys thing_inside
+        ; (pats', res) <- tc_lpats penv pats arg_tys thing_inside
 
-	; dflags <- getDynFlags
+        ; dflags <- getDynFlags
 
-	-- Under flag control turn a pattern (x,y,z) into ~(x,y,z)
-	-- so that we can experiment with lazy tuple-matching.
-	-- This is a pretty odd place to make the switch, but
-	-- it was easy to do.
-	; let pat_ty'          = mkTyConApp tc arg_tys
+        -- Under flag control turn a pattern (x,y,z) into ~(x,y,z)
+        -- so that we can experiment with lazy tuple-matching.
+        -- This is a pretty odd place to make the switch, but
+        -- it was easy to do.
+        ; let pat_ty'          = mkTyConApp tc arg_tys
                                      -- pat_ty /= pat_ty iff coi /= IdCo
               unmangled_result = TuplePat pats' boxity pat_ty'
-	      possibly_mangled_result
-	        | gopt Opt_IrrefutableTuples dflags &&
+              possibly_mangled_result
+                | gopt Opt_IrrefutableTuples dflags &&
                   isBoxed boxity            = LazyPat (noLoc unmangled_result)
-	        | otherwise		    = unmangled_result
+                | otherwise                 = unmangled_result
 
- 	; ASSERT( length arg_tys == length pats )      -- Syntactically enforced
-	  return (mkHsWrapPat coi possibly_mangled_result pat_ty, res)
+        ; ASSERT( length arg_tys == length pats )      -- Syntactically enforced
+          return (mkHsWrapPat coi possibly_mangled_result pat_ty, res)
         }
 
 ------------------------
@@ -513,48 +507,48 @@ tc_pat penv (ConPatIn con arg_pats) pat_ty thing_inside
 ------------------------
 -- Literal patterns
 tc_pat _ (LitPat simple_lit) pat_ty thing_inside
-  = do	{ let lit_ty = hsLitType simple_lit
-	; co <- unifyPatType lit_ty pat_ty
-		-- coi is of kind: pat_ty ~ lit_ty
-	; res <- thing_inside 
-	; return ( mkHsWrapPatCo co (LitPat simple_lit) pat_ty 
+  = do  { let lit_ty = hsLitType simple_lit
+        ; co <- unifyPatType lit_ty pat_ty
+                -- coi is of kind: pat_ty ~ lit_ty
+        ; res <- thing_inside 
+        ; return ( mkHsWrapPatCo co (LitPat simple_lit) pat_ty 
                  , res) }
 
 ------------------------
 -- Overloaded patterns: n, and n+k
 tc_pat _ (NPat over_lit mb_neg eq) pat_ty thing_inside
-  = do	{ let orig = LiteralOrigin over_lit
-	; lit'    <- newOverloadedLit orig over_lit pat_ty
-	; eq'     <- tcSyntaxOp orig eq (mkFunTys [pat_ty, pat_ty] boolTy)
-	; mb_neg' <- case mb_neg of
-			Nothing  -> return Nothing	-- Positive literal
-			Just neg -> 	-- Negative literal
-					-- The 'negate' is re-mappable syntax
- 			    do { neg' <- tcSyntaxOp orig neg (mkFunTy pat_ty pat_ty)
-			       ; return (Just neg') }
-	; res <- thing_inside 
-	; return (NPat lit' mb_neg' eq', res) }
+  = do  { let orig = LiteralOrigin over_lit
+        ; lit'    <- newOverloadedLit orig over_lit pat_ty
+        ; eq'     <- tcSyntaxOp orig eq (mkFunTys [pat_ty, pat_ty] boolTy)
+        ; mb_neg' <- case mb_neg of
+                        Nothing  -> return Nothing      -- Positive literal
+                        Just neg ->     -- Negative literal
+                                        -- The 'negate' is re-mappable syntax
+                            do { neg' <- tcSyntaxOp orig neg (mkFunTy pat_ty pat_ty)
+                               ; return (Just neg') }
+        ; res <- thing_inside 
+        ; return (NPat lit' mb_neg' eq', res) }
 
 tc_pat penv (NPlusKPat (L nm_loc name) lit ge minus) pat_ty thing_inside
-  = do	{ (co, bndr_id) <- setSrcSpan nm_loc (tcPatBndr penv name pat_ty)
+  = do  { (co, bndr_id) <- setSrcSpan nm_loc (tcPatBndr penv name pat_ty)
         ; let pat_ty' = idType bndr_id
-	      orig    = LiteralOrigin lit
-	; lit' <- newOverloadedLit orig lit pat_ty'
+              orig    = LiteralOrigin lit
+        ; lit' <- newOverloadedLit orig lit pat_ty'
 
-	-- The '>=' and '-' parts are re-mappable syntax
-	; ge'    <- tcSyntaxOp orig ge    (mkFunTys [pat_ty', pat_ty'] boolTy)
-	; minus' <- tcSyntaxOp orig minus (mkFunTys [pat_ty', pat_ty'] pat_ty')
+        -- The '>=' and '-' parts are re-mappable syntax
+        ; ge'    <- tcSyntaxOp orig ge    (mkFunTys [pat_ty', pat_ty'] boolTy)
+        ; minus' <- tcSyntaxOp orig minus (mkFunTys [pat_ty', pat_ty'] pat_ty')
         ; let pat' = NPlusKPat (L nm_loc bndr_id) lit' ge' minus'
 
-	-- The Report says that n+k patterns must be in Integral
-	-- We may not want this when using re-mappable syntax, though (ToDo?)
-	; icls <- tcLookupClass integralClassName
-	; instStupidTheta orig [mkClassPred icls [pat_ty']]	
+        -- The Report says that n+k patterns must be in Integral
+        -- We may not want this when using re-mappable syntax, though (ToDo?)
+        ; icls <- tcLookupClass integralClassName
+        ; instStupidTheta orig [mkClassPred icls [pat_ty']]     
     
-	; res <- tcExtendIdEnv1 name bndr_id thing_inside
-	; return (mkHsWrapPatCo co pat' pat_ty, res) }
+        ; res <- tcExtendIdEnv1 name bndr_id thing_inside
+        ; return (mkHsWrapPatCo co pat' pat_ty, res) }
 
-tc_pat _ _other_pat _ _ = panic "tc_pat" 	-- ConPatOut, SigPatOut
+tc_pat _ _other_pat _ _ = panic "tc_pat"        -- ConPatOut, SigPatOut
 
 ----------------
 unifyPatType :: TcType -> TcType -> TcM TcCoercion
@@ -571,7 +565,7 @@ Note [Hopping the LIE in lazy patterns]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 In a lazy pattern, we must *not* discharge constraints from the RHS
 from dictionaries bound in the pattern.  E.g.
-	f ~(C x) = 3
+        f ~(C x) = 3
 We can't discharge the Num constraint from dictionaries bound by
 the pattern C!  
 
@@ -580,9 +574,9 @@ the pattern.  Hence the captureConstraints and emitConstraints.
 
 The same thing ensures that equality constraints in a lazy match
 are not made available in the RHS of the match. For example
-	data T a where { T1 :: Int -> T Int; ... }
-	f :: T a -> Int -> a
-	f ~(T1 i) y = y
+        data T a where { T1 :: Int -> T Int; ... }
+        f :: T a -> Int -> a
+        f ~(T1 i) y = y
 It's obviously not sound to refine a to Int in the right
 hand side, because the arugment might not match T1 at all!
 
@@ -591,10 +585,10 @@ because they won't be in scope when we do the desugaring
 
 
 %************************************************************************
-%*									*
-	Most of the work for constructors is here
-	(the rest is in the ConPatIn case of tc_pat)
-%*									*
+%*                                                                      *
+        Most of the work for constructors is here
+        (the rest is in the ConPatIn case of tc_pat)
+%*                                                                      *
 %************************************************************************
 
 [Pattern matching indexed data types]
@@ -651,85 +645,85 @@ equality constraints that are used in conjunction with implication constraints
 to express the local scope of GADT refinements.
 
 \begin{code}
---	Running example:
+--      Running example:
 -- MkT :: forall a b c. (a~[b]) => b -> c -> T a
--- 	 with scrutinee of type (T ty)
+--       with scrutinee of type (T ty)
 
 tcConPat :: PatEnv -> Located Name 
-	 -> TcRhoType  	       	-- Type of the pattern
-	 -> HsConPatDetails Name -> TcM a
-	 -> TcM (Pat TcId, a)
+         -> TcRhoType           -- Type of the pattern
+         -> HsConPatDetails Name -> TcM a
+         -> TcM (Pat TcId, a)
 tcConPat penv (L con_span con_name) pat_ty arg_pats thing_inside
-  = do	{ data_con <- tcLookupDataCon con_name
-	; let tycon = dataConTyCon data_con
-         	  -- For data families this is the representation tycon
-	      (univ_tvs, ex_tvs, eq_spec, theta, arg_tys, _)
+  = do  { data_con <- tcLookupDataCon con_name
+        ; let tycon = dataConTyCon data_con
+                  -- For data families this is the representation tycon
+              (univ_tvs, ex_tvs, eq_spec, theta, arg_tys, _)
                 = dataConFullSig data_con
 
-	  -- Instantiate the constructor type variables [a->ty]
-	  -- This may involve doing a family-instance coercion, 
-	  -- and building a wrapper 
-	; (wrap, ctxt_res_tys) <- matchExpectedPatTy (matchExpectedConTy tycon) pat_ty
+          -- Instantiate the constructor type variables [a->ty]
+          -- This may involve doing a family-instance coercion, 
+          -- and building a wrapper 
+        ; (wrap, ctxt_res_tys) <- matchExpectedPatTy (matchExpectedConTy tycon) pat_ty
 
-	  -- Add the stupid theta
-	; setSrcSpan con_span $ addDataConStupidTheta data_con ctxt_res_tys
+          -- Add the stupid theta
+        ; setSrcSpan con_span $ addDataConStupidTheta data_con ctxt_res_tys
 
-	; checkExistentials ex_tvs penv 
+        ; checkExistentials ex_tvs penv 
         ; (tenv, ex_tvs') <- tcInstSuperSkolTyVarsX
                                (zipTopTvSubst univ_tvs ctxt_res_tys) ex_tvs
                      -- Get location from monad, not from ex_tvs
 
         ; let pat_ty' = mkTyConApp tycon ctxt_res_tys
-	      -- pat_ty' is type of the actual constructor application
+              -- pat_ty' is type of the actual constructor application
               -- pat_ty' /= pat_ty iff coi /= IdCo
               
-	      arg_tys' = substTys tenv arg_tys
+              arg_tys' = substTys tenv arg_tys
 
         ; traceTc "tcConPat" (ppr con_name $$ ppr ex_tvs' $$ ppr pat_ty' $$ ppr arg_tys')
-	; if null ex_tvs && null eq_spec && null theta
-	  then do { -- The common case; no class bindings etc 
+        ; if null ex_tvs && null eq_spec && null theta
+          then do { -- The common case; no class bindings etc 
                     -- (see Note [Arrows and patterns])
-		    (arg_pats', res) <- tcConArgs data_con arg_tys' 
-						  arg_pats penv thing_inside
-		  ; let res_pat = ConPatOut { pat_con = L con_span data_con, 
-			            	      pat_tvs = [], pat_dicts = [], 
+                    (arg_pats', res) <- tcConArgs data_con arg_tys' 
+                                                  arg_pats penv thing_inside
+                  ; let res_pat = ConPatOut { pat_con = L con_span data_con, 
+                                              pat_tvs = [], pat_dicts = [], 
                                               pat_binds = emptyTcEvBinds,
-					      pat_args = arg_pats', 
+                                              pat_args = arg_pats', 
                                               pat_ty = pat_ty' }
 
-		  ; return (mkHsWrapPat wrap res_pat pat_ty, res) }
+                  ; return (mkHsWrapPat wrap res_pat pat_ty, res) }
 
-	  else do   -- The general case, with existential, 
+          else do   -- The general case, with existential, 
                     -- and local equality constraints
-	{ let theta'   = substTheta tenv (eqSpecPreds eq_spec ++ theta)
+        { let theta'   = substTheta tenv (eqSpecPreds eq_spec ++ theta)
                            -- order is *important* as we generate the list of
                            -- dictionary binders from theta'
-	      no_equalities = not (any isEqPred theta')
+              no_equalities = not (any isEqPred theta')
               skol_info = case pe_ctxt penv of
                             LamPat mc -> PatSkol data_con mc
                             LetPat {} -> UnkSkol -- Doesn't matter
  
         ; gadts_on    <- xoptM Opt_GADTs
         ; families_on <- xoptM Opt_TypeFamilies
-	; checkTc (no_equalities || gadts_on || families_on)
-		  (ptext (sLit "A pattern match on a GADT requires GADTs or TypeFamilies"))
-		  -- Trac #2905 decided that a *pattern-match* of a GADT
-		  -- should require the GADT language flag.  
+        ; checkTc (no_equalities || gadts_on || families_on)
+                  (ptext (sLit "A pattern match on a GADT requires GADTs or TypeFamilies"))
+                  -- Trac #2905 decided that a *pattern-match* of a GADT
+                  -- should require the GADT language flag.  
                   -- Re TypeFamilies see also #7156 
 
         ; given <- newEvVars theta'
         ; (ev_binds, (arg_pats', res))
-	     <- checkConstraints skol_info ex_tvs' given $
+             <- checkConstraints skol_info ex_tvs' given $
                 tcConArgs data_con arg_tys' arg_pats penv thing_inside
 
         ; let res_pat = ConPatOut { pat_con   = L con_span data_con, 
-			            pat_tvs   = ex_tvs',
-			            pat_dicts = given,
-			            pat_binds = ev_binds,
-			            pat_args  = arg_pats', 
+                                    pat_tvs   = ex_tvs',
+                                    pat_dicts = given,
+                                    pat_binds = ev_binds,
+                                    pat_args  = arg_pats', 
                                     pat_ty    = pat_ty' }
-	; return (mkHsWrapPat wrap res_pat pat_ty, res)
-	} }
+        ; return (mkHsWrapPat wrap res_pat pat_ty, res)
+        } }
 
 ----------------------------
 matchExpectedPatTy :: (TcRhoType -> TcM (TcCoercion, a))
@@ -740,8 +734,8 @@ matchExpectedPatTy inner_match pat_ty
   | null tvs && null theta
   = do { (co, res) <- inner_match pat_ty
        ; return (coToHsWrapper (mkTcSymCo co), res) }
-       	 -- The Sym is because the inner_match returns a coercion
-	 -- that is the other way round to matchExpectedPatTy
+         -- The Sym is because the inner_match returns a coercion
+         -- that is the other way round to matchExpectedPatTy
 
   | otherwise
   = do { (_, tys, subst) <- tcInstTyVars tvs
@@ -752,35 +746,35 @@ matchExpectedPatTy inner_match pat_ty
     (tvs, theta, tau) = tcSplitSigmaTy pat_ty
 
 ----------------------------
-matchExpectedConTy :: TyCon  	 -- The TyCon that this data 
-		    		 -- constructor actually returns
-		   -> TcRhoType  -- The type of the pattern
-		   -> TcM (TcCoercion, [TcSigmaType])
+matchExpectedConTy :: TyCon      -- The TyCon that this data 
+                                 -- constructor actually returns
+                   -> TcRhoType  -- The type of the pattern
+                   -> TcM (TcCoercion, [TcSigmaType])
 -- See Note [Matching constructor patterns]
 -- Returns a coercion : T ty1 ... tyn ~ pat_ty
 -- This is the same way round as matchExpectedListTy etc
 -- but the other way round to matchExpectedPatTy
 matchExpectedConTy data_tc pat_ty
   | Just (fam_tc, fam_args, co_tc) <- tyConFamInstSig_maybe data_tc
-    	 -- Comments refer to Note [Matching constructor patterns]
-     	 -- co_tc :: forall a. T [a] ~ T7 a
+         -- Comments refer to Note [Matching constructor patterns]
+         -- co_tc :: forall a. T [a] ~ T7 a
   = do { (_, tys, subst) <- tcInstTyVars (tyConTyVars data_tc)
-       	     -- tys = [ty1,ty2]
+             -- tys = [ty1,ty2]
 
        ; traceTc "matchExpectedConTy" (vcat [ppr data_tc, 
                                              ppr (tyConTyVars data_tc),
                                              ppr fam_tc, ppr fam_args])
        ; co1 <- unifyType (mkTyConApp fam_tc (substTys subst fam_args)) pat_ty
-       	     -- co1 : T (ty1,ty2) ~ pat_ty
+             -- co1 : T (ty1,ty2) ~ pat_ty
 
        ; let co2 = mkTcUnbranchedAxInstCo co_tc tys
-       	     -- co2 : T (ty1,ty2) ~ T7 ty1 ty2
+             -- co2 : T (ty1,ty2) ~ T7 ty1 ty2
 
        ; return (mkTcSymCo co2 `mkTcTransCo` co1, tys) }
 
   | otherwise
   = matchExpectedTyConApp data_tc pat_ty
-       	     -- coi : T tys ~ pat_ty
+             -- coi : T tys ~ pat_ty
 \end{code}
 
 Note [Matching constructor patterns]
